<template>
  <div class="steps">
    <ul class="timeline">
      <template
        v-for="step in steps"
      >
        <ride-action
          v-if="step.type === 'ride'"
          :key="step.id"
          :step="step"
          :class="{ 'is-active': isActive(step) }"
        />
        <shuttle-action
          v-else
          :key="step.id"
          :step="step"
          :class="{ 'is-active': isActive(step) }"
        />
      </template>
    </ul>
  </div>
</template>

<script>
import rideAction from '~/components/step/ride-action.vue';
import shuttleAction from '~/components/step/shuttle-action.vue';

export default {
  components: {
    rideAction, shuttleAction,
  },
  props: {
    steps: {
      type: Array,
      default: () => [],
    },
    currentStep: {
      type: Object,
      default: () => ({}),
    },
  },
  methods: {
    isActive(step) {
      return step[step.type].id === this.currentStep[this.currentStep.type].id;
    },
  },
};
</script>

<style lang="scss">
  @import "~assets/css/head";

  .steps {
    padding-left: 60px;
    padding-bottom: 50px;

  }
  ul.timeline {
    list-style-type: none;
    margin: 0;
    padding: 0;
    position: relative;
    transition: all 0.5s linear;
    top: 0;

    &:before {
      content: "";
      display: block;
      width: 0;
      height: 100%;
      border: 1px dashed $gray;
      position: absolute;
      top: 0;
      left: 30px;
    }

    > li {
      margin: 20px 60px 60px;
      position: relative;
      padding: 10px 20px;
      border-radius: 10px;
      line-height: 20px;
      color: $gray;

      .title {
        font-weight: 700;
        margin-bottom: .5rem;
        font-size: 1.3rem;
        color: $gray;
      }

      .when {
        position: absolute;
        left: -100px;
        color: $gray;
        font-size: 80%;
        font-weight: bold;
        top: -15px;
        width: 65px;
      }

      > span {
        content: "";
        display: block;
        width: 0;
        height: 100%;
        border: 1px solid $gray;
        position: absolute;
        top: 0;
        left: -30px;

        &:before, &:after {
          content: "";
          display: block;
          width: 10px;
          height: 10px;
          border-radius: 50%;
          border: 2px solid $gray;
          background: $white;
          position: absolute;
          left: -5px;
        }
        &:before {
          top: -10px;
        }
        &:after {
          top: 95%;
        }
      }
      &.is-active {
        color: $text;
        .title {
          color: $text;
        }
        .when {
          color: $text;
        }
        > span {
          border: 1px solid $text;
          &:before, &:after {
            border: 2px solid $text;
          }
        }
      }
    }
  }
  </style>
